
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <GL/gl.h>

#include "defines.h"
#include "png.h"



int main(int argc, char *argv[]) {

  unsigned char *d, *t, m[4];
  int dx, dy, type, i, n, x, y;
  FILE *f;


  if (argc != 3) {
    fprintf(stderr, "USAGE: %s <PNG FILE> <OUT FILE>\n", argv[0]);
    return -1;
  }

  if (png_load(argv[1], &dx, &dy, &type, &d) == FAILED)
    return -1;

  /* no alpha? no saving? */
  if (type == GL_RGB)
    n = 3;
  else
    n = 4;

  t = malloc(20*(18*4));
  if (t == NULL) {
    fprintf(stderr, "MAIN: Out of memory error.\n");
    return -1;
  }

  for (i = 0, y = 0; y < 18*4; y++) {
    for (x = 0; x < 20; x++, i++) {
      m[0] = d[y*dx*n + x*4*n + 0*n];
      m[1] = d[y*dx*n + x*4*n + 1*n];
      m[2] = d[y*dx*n + x*4*n + 2*n];
      m[3] = d[y*dx*n + x*4*n + 3*n];
      t[i] = ((m[0]>>6)<<6) | ((m[1]>>6)<<4) | ((m[2]>>6)<<2) | (m[3]>>6);
    }
  }

  f = fopen(argv[2], "wb");
  if (f == NULL) {
    fprintf(stderr, "MAIN: Could not open file \"%s\" for writing.\n", argv[2]);
    free(t);
    free(d);
    return 1;
  }

  fwrite(t, 1, 20*18*4, f);
  fclose(f);

  free(t);
  free(d);

  return 0;
}
